unit MainUnit;
//   : !!!
//{$DEFINE DEBUG}

{$I ../inc/comparam.inc}

interface

uses Windows, XPMan, Dialogs, StdCtrls, ExtCtrls, Controls, ComCtrls,
  Classes, Graphics, Forms, ScktComp, Buttons,
  JPEG, Types, INIFiles, SysUtils;

const
  {$I ../inc/consts.inc}

   MsgEnterCount  = 10;
   MsgLeaveCount  = 15;

   SkinPath       = 'Skins';
   SkinMainFile   = 'scskin.ini';

   DefWndChatColor		    = clWindow;
   DefWndChatTextColor	  = clBlack;
   DefWndUsersColor		    = clWindow;
   DefWndUsersTextColor	  = clWindowText;
	 DefWndTypeColor		    = clWindow;
	 DefWndTypeTextColor	  = clWindowText;
	 DefWndMainTextColor	  = clMaroon;
	 DefWndStatusBgColor	  = clMoneyGreen;
	 DefWndTypeBgColor		  = clSkyBlue;
   DefLambdaColor         = clGray;
   DefPrivRecvHL          = $7DF57D;
   DefPrivSendHl          = $7D7DFF;

   DefNickColor           = $ff0000;

   //     
   ArrMsgEnter : array[0..MsgEnterCount - 1] of String = (
                     '   ...',
                     '    ...',
                     ' ...',
                     ' online... .  .   .',
                     '  .',
                     '   .',
                     ' !',
                     '   .',
                     '    .',
                     '   .'
                  );
   //    
   ArrMsgLeave : array[0..MsgLeaveCount - 1] of String = (
                     '  ...',
                     '  .',
                     ' .',
                     '      .',
                     '    .',
                     '    .',
                     '    ...',
                     '  ,  .',
                     '   .',
                     '     ?',
                     '       .',
                     '  .',
                     '    .',
                     ' , ,  .',
                     '  9 .'
                  );
   Hint0btnConn = '  ';
   Hint1btnConn = ' ';
type
  {$I ../inc/structs.inc}
  PUserList = ^TUserList;
  TUserList = record
      UserParams: TUser;
      NextRecord: PUserList;
      PrevRecord: PUserList;
  End;
  TSkinParam = record
      SkinName:     String;
      SkinAuthor:   String;
      SkinVersion:  String;
      SkinDir:      String;
  End;
  PSkinParam = ^TSkinParam;
  TfrmMain = class(TForm)
    pnMain: TPanel;
    pnChat: TPanel;
    statusPanel: TStatusBar;
    pnType: TPanel;
    pnStatus: TPanel;
    edChat: TEdit;
    btnSend: TSpeedButton;
    edPort: TEdit;
    edAddress: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    btnConn: TSpeedButton;
    edNick: TEdit;
    Label4: TLabel;
    btnClNick: TSpeedButton;
    Bevel1: TBevel;
    dlgClNick: TColorDialog;
    lbChat: TListBox;
    lbUserList: TListBox;
    cbPrivate: TCheckBox;
    btnAvatar: TSpeedButton;
    imgBgStatus: TImage;
    imgBgType: TImage;
    cbSkinSelect: TComboBox;
    Bevel2: TBevel;
    Label5: TLabel;
    stAbout: TStaticText;
    XPManifest: TXPManifest;
    procedure FormCreate(Sender: TObject);
    procedure edKeyPress(Sender: TObject; var Key: Char);
    procedure btnSendClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnCtrlsClick(Sender: TObject);
    procedure lbChatDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure lbUserListDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure lbChatMeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
    procedure lbUserListMeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
    procedure cbPrivateClick(Sender: TObject);
    procedure lbUserListDblClick(Sender: TObject);
    procedure lbUserListClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure cbSkinSelectSelect(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
     ClnSock: TClientSocket;
     PrivEnabled: Boolean;
     BmpOpen, BmpClose: TBitmap;
     //       
     CurUser: PUserList;
     //     
     FirstUser: PUserList;
     Iam: TUser;                //   
     Lambda: TUser;             // 
     PrivSendHl: TColor;        //    
     PrivRecvHl: TColor;        //  
     procedure ClnSockRead(Sender: TObject; Socket: TCustomWinSocket);
     procedure ClnSockConnect(Sender: TObject; Socket: TCustomWinSocket);
     procedure ClnSockDisConnect(Sender: TObject; Socket: TCustomWinSocket);
     procedure ClnSockError(Sender: TObject; Socket: TCustomWinSocket;
       ErrorEvent: TErrorEvent; var ErrorCode: Integer);

     procedure ConnectCln;
     procedure DisConnectCln;
     procedure AfterDisconnectCln;
     procedure StrSplit(const Src: String; Var FirstStr, LastStr: String; Splitter: Char = ctrlSym);
     procedure AddUser(const Nick: String);
     procedure AddMsgToList(const Msg, Nick: String; MsgType: Byte = mtPublic);
     procedure ClearUserList();
     procedure ClearChatMsgList();
     function GetInfoByNick(const Nick: String) : PUser;
     function ParseCmd(Var Cmd, CmdParam: String) : String;
     procedure ParseServerInfo(Value : String);
     procedure RunCmd(CmdString: String);
     procedure LoadSettings();
     procedure SaveSettings();
     procedure EnumSkins;
     function LoadSkin(Skin: PSkinParam) : Boolean;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation
//---------------------------------------------------------------------------
{$R *.dfm}
{$R Client.res}
//---------------------------------------------------------------------------
procedure TfrmMain.ClearUserList();
Var NUser: PUserList;
Begin
  while (FirstUser <> nil)
    do
      Begin
        NUser := FirstUser.NextRecord;
        Dispose(FirstUser);
        FirstUser := NUser;
      End;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.ClearChatMsgList;
//  -    
Begin
   while (lbChat.Count > 0)
      do
         Begin
            if (PMsgParams(lbChat.Items.Objects[lbChat.Count - 1]) <> nil) Then
              Dispose(PMsgParams(lbChat.Items.Objects[lbChat.Count - 1]));
            lbChat.Items.Delete(lbChat.Count - 1);
         End;
   lbChat.ScrollWidth := 0;
End;
//---------------------------------------------------------------------------
function TfrmMain.ParseCmd;
//    
//  ''   

Var I: Integer;
    Param: String;
    Link: ^String;         //    

Begin
   //   
   Link     := @Param;
   CmdParam := '';
   //   - __ . .
   for I:=2 To Length(Cmd)
      Do
         Begin
            if (Cmd[i] = ctrlSym) Then break; // [1]
            if ((Cmd[i] = delimSym) and (Link <> @CmdParam)) Then
            //        
               Begin
                  // [2]
                  Link := @CmdParam;
                  continue;
               End;
            Link^ := Link^ + Cmd[I];
         End;
   //   
   Cmd      := Copy(Cmd, I, Length(Cmd) - I + 1);
   Result   := Param;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.ParseServerInfo(Value : String);
// !!!
Var V1, V2 : String;
    SrvVersion, SrvComment : String;
Begin
  V1 := '';
  while (Value <> '') do
    Begin
      StrSplit(Value, V1, V2, delimSym);
      Value := V2;
      if (V1 = 'Version') Then
        Begin
          StrSplit(Value, V1, V2, ';');
          Value       := V2;
          SrvVersion  := V1;
        End
      else if (V1 = 'Name') Then
        Begin
          StrSplit(Value, V1, V2, ';');
          Lambda.Nick := V1;
          Value := V2;
        End
      else if (V1 = 'Comment') Then
        Begin
          StrSplit(Value, V1, V2, ';');
          SrvComment  := V1;
          Value       := V2;
        End;
  End;
  AddMsgToList(' : ' + SrvVersion, Lambda.Nick, mtPublic);
  AddMsgToList(SrvComment, Lambda.Nick, mtPublic);
End;
//---------------------------------------------------------------------------
function TfrmMain.GetInfoByNick(const Nick: String) : PUser;
//    
Var I: Integer;
Begin
   if (Nick = Iam.Nick) Then
      Begin
        Result := @Iam;
        Exit;
      End;
   if (Nick = Lambda.Nick) Then
      Begin
        Result := @Lambda;
        Exit;
      End;
   for i := 0 To lbUserList.Count - 1
      Do
         Begin
            if (PUser(lbUserList.Items.Objects[i])^.Nick = Nick) Then
               Begin
                  Result := PUser(lbUserList.Items.Objects[i]);
                  exit;
               End;
         End;
   Result := nil;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.AddUser(const Nick: String);
//    
Begin
  if (CurUser <> nil) Then
    Begin
      New(CurUser.NextRecord);
      CurUser^.NextRecord.PrevRecord  := CurUser;
      CurUser                         := CurUser.NextRecord;
    End
  else
    Begin
      New(CurUser);
      CurUser^.PrevRecord := nil;
      FirstUser           := CurUser;
    End;
  CurUser^.NextRecord       := nil;
  CurUser^.UserParams.Nick  := Nick;
  lbUserList.Items.AddObject(Nick, TObject(CurUser));
End;
//---------------------------------------------------------------------------
procedure TfrmMain.AddMsgToList(const Msg, Nick: String; MsgType: Byte);
//    
Var Info: PMsgParams;

Begin
   //      
   New(Info);
   Info.UserParams  := GetInfoByNick(Nick);
   Info.MsgType     := MsgType;
   //       -  (  )
   if (Info.UserParams = nil) then
      Begin
        Dispose(Info);
        exit;
      End;
   lbChat.Items.AddObject(Msg, TObject(Info));
   lbChat.ItemIndex := lbChat.Count - 1;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.ConnectCln;
//  
Var
    OnClickEvent : TNotifyEvent;

Begin
   OnClickEvent      := btnConn.OnClick;
   try
   btnConn.OnClick   := nil;
   if (edNick.Text = '') Then
      Begin
         MessageBox(Application.Handle, '    !',
         '!', MB_ICONERROR or MB_OK);
         edNick.SetFocus;
         exit;
      End;
      lbChat.Clear;
      //   
      edChat.MaxLength  := MaxStrLen - Length(edNick.Text) - 2;
      clnSock.Port      := StrToIntDef(edPort.Text, DefPort);
      edPort.Text       := IntToStr(clnSock.Port);
      clnSock.Address   := edAddress.Text;
      clnSock.Open;
      finally
        btnConn.OnClick   := OnClickEvent;
      end;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.DisconnectCln;
//  
Begin
   ClnSock.Close;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.AfterDisconnectCln;
// ,   
Var OnClickEvent : TNotifyEvent;

Begin
   OnClickEvent      := btnConn.OnClick;
   btnConn.OnClick   := nil;
   ClearChatMsgList();
   lbUserList.Clear();
   ClearUserList();
   btnConn.Glyph.Assign(bmpOpen);
   edAddress.Enabled := true;
   edPort.Enabled    := true;
   edNick.Enabled    := true;
   btnClNick.Enabled := true;
   edPort.Enabled    := true;
   edAddress.Enabled := true;
   if (PrivEnabled) Then cbPrivateClick(cbPrivate);
   btnConn.OnClick   := OnClickEvent;
   btnConn.Hint      := Hint0btnConn;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.ClnSockError;
//  
Begin
   //
   AfterDisconnectCln;
   ErrorCode := 0;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.RunCmd;
//  
Var Value, Key, Nick: String;

Begin
   Repeat
      if (CmdString[1] <> ctrlSym) Then break;
      Key := ParseCmd(CmdString, Value);

      if (Key = 'ID') Then
      // ID
      Begin
         Nick := Value;
         continue;
      End;
      if (Key = 'NICK') Then
      // Nick  
      Begin
         GetInfoByNick(Nick)^.Nick := Value;
         continue;
      End;
      if (Key = 'NICK_COLOR') Then
      // Nick   
         Begin
            GetInfoByNick(Nick)^.NickColor := StrToIntDef(Value, 0);
            continue;
         End;
      if (Key = 'CONNECT') Then
         Begin
            AddUser(Nick);
            AddMsgToList(Nick + ArrMsgEnter[random(MsgEnterCount)],
                         Lambda.Nick, mtPublic);
            continue;
         End;
      if (Key = 'DISCONNECT') Then
         Begin
            With lbUserList.Items
               Do
                  Begin
                  //      
                  //     lbUserList
                     Delete(lbUserList.Items.IndexOf(Nick));
                     if (lbUserList.ItemIndex < 0) Then cbPrivate.Enabled := false;
                     //   Lambda   
                     AddMsgToList(Nick + ArrMsgLeave[random(MsgLeaveCount)],
                                  Lambda.Nick, mtPublic);
                  End;
            continue;
         End;
      if (Key = 'PRIVATE') Then
      //  
         Begin
            AddMsgToList(Value, Nick, mtPrivateRecv);
            continue;
         End;
      if (Key = 'ONLINE') Then
         Begin
            New(CurUser);
            CurUser.UserParams.Nick := Nick;
            lbUserList.Items.AddObject(Nick, TObject(CurUser));
            continue;
         End;
      if (Key = 'ERROR') Then
         Begin
            if (Value = 'ERR_PRIVATE_DECLINED') Then
            //     
               Begin
                  PrivEnabled := true;
                  cbPrivateClick(cbPrivate);
               End
            else if (ClnSock.Active) then ClnSock.Close;
            continue;
         End;
      if (Key = 'BYE') Then
         Begin
            ClnSock.Close();
            exit;
         End;
      if (Key = 'SERVERINFO') Then
      Begin
        ParseServerInfo(Value);
        continue;
      End;
   Until ((Key = '') or (CmdString = ''));
End;
//---------------------------------------------------------------------------
procedure TfrmMain.ClnSockRead;
//   
Var TxtBuf: String;
    Nick, Msg: String;

Begin
   TxtBuf := Socket.ReceiveText;
   if (TxtBuf = '') Then exit;
   if (TxtBuf[1] <> ctrlSym) Then
   //  
      Begin
         StrSplit(TxtBuf, Nick, Msg);
         AddMsgToList(Msg, Nick);
         exit;
      End;
   //  
   RunCmd(TxtBuf);
End;
//---------------------------------------------------------------------------
procedure TfrmMain.ClnSockConnect;
Begin
   btnConn.Glyph.Assign(bmpClose);
   btnConn.Hint      := Hint1btnConn;   
   edAddress.Enabled := false;
   edPort.Enabled    := false;
   edNick.Enabled    := false;
   btnClNick.Enabled := false;
   edPort.Enabled    := false;
   edAddress.Enabled := false;
   Socket.SendText(ctrlSym + 'NICK' + delimSym + edNick.Text + ctrlSym +
   'NICK_COLOR' + delimSym + IntToStr(dlgClNick.Color));
   Socket.SendText(ctrlSym + 'GET_USER_LIST');
   Socket.SendText(ctrlSym + 'GET_SERVER_INFO');
End;
//---------------------------------------------------------------------------
procedure TfrmMain.ClnSockDisconnect;
Begin
   AfterDisconnectCln;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.FormCreate(Sender: TObject);

begin
   btnConn.Hint            := Hint0btnConn;
   bmpOpen                 := TBitmap.Create;
   bmpClose                := TBitmap.Create;
   bmpOpen.LoadFromResourceName(hInstance, 'BMP_OPEN');
   bmpClose.LoadFromResourceName(hInstance, 'BMP_CLOSE');
   PrivEnabled             := false;
   statusPanel.SimpleText  := statusPanel.SimpleText + ' - Version: ' + ChatVersion;
   clnSock                 := TClientSocket.Create(Application);
   clnSock.OnRead          := ClnSockRead;
   clnSock.OnError         := ClnSockError;
   clnSock.OnConnect       := ClnSockConnect;
   clnSock.OnDisconnect    := ClnSockDisConnect;
   clnSock.ClientType      := ctNonBlocking;
   btnConn.Glyph.LoadFromResourceName(hInstance, 'BMP_OPEN');
   EnumSkins();
   Lambda.Nick             := 'lambda';
   Lambda.NickColor        := DefLambdaColor;
   PrivRecvHL              := DefPrivRecvHL;
   PrivSendHL              := DefPrivSendHL;
   With lbChat
      Do
         Begin
//            DoubleBuffered   := true;
            Canvas.Font      := lbChat.Font;
            Canvas.Pen.Mode  := pmCopy;
            Canvas.Pen.Style := psSolid;
            Canvas.Pen.Color := clWhite;
            Canvas.Brush.Color := Color;
         End;

   With lbUserList
      Do
         Begin
            Canvas.Font      := lbUserList.Font;
            Canvas.Pen.Mode  := pmCopy;
            Canvas.Pen.Style := psSolid;
            Canvas.Pen.Color := clWhite;
         End;
   LoadSettings;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.edKeyPress(Sender: TObject; var Key: Char);
//   Enter
begin
   if (Key = #13) Then
      Begin
         if (Sender = edChat)          Then btnSend.Click
         else if (Sender = edNick)     Then btnClNick.Click
         else if (Sender = edAddress)  Then btnConn.Click
         else if (Sender = edPort)     Then btnConn.Click;
         Key := #0;
      End;
   //   
   if (Key = #27) Then Key := #0;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.btnSendClick(Sender: TObject);
begin
   if (ClnSock.Active and (edChat.Text <> '')) Then
      Begin
         //      
         if (PrivEnabled) then
         //     
            Begin
              AddMsgToList(edChat.Text, Iam.Nick, mtPrivateSend);
            End
         else
            Begin
              AddMsgToList(edChat.Text, Iam.Nick, mtPublic);
            End;
         ClnSock.Socket.SendText(edChat.Text);
         edChat.Clear;
      End;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.FormDestroy(Sender: TObject);
begin
   SaveSettings();
   with cbSkinSelect.Items do
   while (Count > 0) do
   //  ,   
    Begin
      if (Objects[Count - 1] <> nil) Then Dispose(PSkinParam(Objects[Count - 1]));
      Delete(Count - 1);
    End;
   bmpOpen.Free;
   bmpClose.Free;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.btnCtrlsClick(Sender: TObject);
begin
//
   if (Sender = btnConn) Then
   // ""
      Begin
         Iam.NickColor := dlgClNick.Color;
         Iam.Nick      := edNick.Text;
         if (Not ClnSock.Active) Then ConnectCln
         Else DisconnectCln;
      End
   else if (Sender = btnClNick) Then
   // "  "
      Begin
         if (dlgClNick.Execute) Then
            Begin
               if (Not (dlgClNick.Color = clWhite)) Then
                  Begin
                     edNick.Font.Color := dlgClNick.Color;
                  End;
            End;
      End;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.StrSplit(const Src: String; Var FirstStr, LastStr: String; Splitter: Char);
Var PStr: ^String;
    I: Integer;
Begin
   //     
   FirstStr := '';
   LastStr  := '';
   PStr     := @FirstStr;
   for i := 1 to Length(Src)
      Do
         Begin
            if ((Src[i] = Splitter) And (PStr <> @LastStr)) Then
               Begin
                  PStr := @LastStr;
                  continue;
               End;
            PStr^ := PStr^ + Src[i];
         End;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.lbChatDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
//   
Var lFontColor, lBrushColor: TColor;
    Nick, Msg, TmpMsg: String;
    X, Y, WindowW : Integer;
    LPenColor : TColor;
    // .     
    SymCount: Integer;
    SymPos, MsgLen: Integer;

begin
   if (PMsgParams(lbChat.Items.Objects[Index]) <> nil) Then
      Nick := PMsgParams(lbChat.Items.Objects[Index])^.UserParams.Nick
   else Nick := Lambda.Nick;
   Msg      := lbChat.Items.Strings[Index];
   //CenterY  := Rect.Top + Trunc((Rect.Bottom - Rect.Top) / 2);
   With lbChat.Canvas
      Do
         Begin
            lFontColor  := Font.Color;
            lBrushColor := Brush.Color;
            LPenColor   := Pen.Color;
            if (lbChat.Items.Objects[Index] <> nil) Then
              Font.Color := PMsgParams(lbChat.Items.Objects[Index])^.UserParams.NickColor
            else Font.Color := Lambda.NickColor;
            //   ,    
            if (odSelected in State) Then
               Begin
                  Brush.Color := clRed;
                  lFontColor  := lbChat.Font.Color;
                  //    
                  if (lbChat.Color = clBlack) Then Pen.Color := clWhite
                  else Pen.Color   := clBlack;
//                  X           := Rect.Left + TextWidth(Nick + ': ' + Msg) + 10;
//                  Y           := CenterY - btnSend.Glyph.Height;
                  X := 1;
                  Y := Rect.Top + 1;
{                  MoveTo(X, Y);
                  LineTo(X + 5, Y - 5);
                  LineTo(X + 5, Y + 5);
                  LineTo(X, Y);
                  FloodFill(X + 2, Y, Pen.Color, fsBorder);}
                  Draw(X, Y, btnSend.Glyph);
                  Brush.Color := lbChat.Color;
               End
            //    
            else
               Begin
                  Pen.Color := lbChat.Color;
                  Rectangle(Rect);
               End;
            //   ,    
            if (lbChat.Items.Objects[Index] <> nil) Then
              Begin
                if (PMsgParams(lbChat.Items.Objects[Index])^.MsgType = mtPrivateRecv) Then
                   Brush.Color := PrivRecvHl
                else if (PMsgParams(lbChat.Items.Objects[Index])^.MsgType = mtPrivateSend) Then
                   Brush.Color := PrivSendHl
                else Brush.Color := lbChat.Color;
              End
            else Brush.Color := lbChat.Color;
            Y           := Rect.Top + 1;
            WindowW     := lbChat.Width - 30;
            TextOut(Rect.Left + btnSend.Glyph.Width + 2, Y, Nick + ':');
            Font.Color := lFontColor;
            //      
            Brush.Color := lbChat.Color;
            X           := btnSend.Glyph.Width + 2;
            MsgLen      := Length(Msg);
            SymCount    := Trunc(lbChat.Width / TextWidth(Msg[1]));
            SymPos      := SymCount - Length(Nick) + 1;
            TmpMsg      := Copy(Msg, 1, SymPos);
            while ((TextWidth(Nick + ': ' + TmpMsg) + X < WindowW) and
                   (SymPos < MsgLen))
              Do
                Begin
                  SymPos  := SymPos + 1;
                  TmpMsg  := TmpMsg + Msg[SymPos];
                End;
            TextOut(X + TextWidth(Nick + ':'), Y, ' ' + TmpMsg);
            while (SymPos < Length(Msg))
              Do
                Begin
                  Y         := Y + TextHeight(TmpMsg) + 2;
                  SymCount  := SymCount - 1;
                  TmpMsg    := Copy(Msg, SymPos + 1, SymCount);
                  while ((TextWidth(TmpMsg) < WindowW) and
                         (SymPos + SymCount < MsgLen))
                    Do
                      Begin
                        SymCount  := SymCount + 1;
                        TmpMsg    := TmpMsg + Msg[SymPos + SymCount];
                      End;
                  TextOut(2, Y, TmpMsg);
                  SymPos    := SymPos + SymCount;
                  SymCount  := Trunc(lbChat.Width / TextWidth(Msg[1]));
                End;
            Brush.Color := lBrushColor;
            Pen.Color   := LPenColor;

         End;

end;
//---------------------------------------------------------------------------
procedure TfrmMain.lbUserListDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
Var lColor: TColor;
    Nick: String;

begin
   Nick := PUser(lbUserList.Items.Objects[Index])^.Nick;
   With lbUserList.Canvas
      Do
         Begin
            Brush.Color := lbUserList.Color;
            lColor      := Font.Color;
            Font.Color  := PUser(lbUserList.Items.Objects[Index])^.NickColor;
            if (not (odSelected in State)) Then
            //   
              Begin
                Pen.Color := lbUserList.Color;
                Rectangle(Rect);
              End
            else
            //  
              Begin
                Pen.Color := PUser(lbUserList.Items.Objects[Index])^.NickColor;
                Rectangle(Rect);
              End;
            TextOut(Rect.Left, Rect.Top, Nick);
            Font.Color := lColor;
         End;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.lbChatMeasureItem(Control: TWinControl; Index: Integer;
  var Height: Integer);
//   ,       
Var WindowW:    Integer;
    TextW:      Integer;
    LineCount:  Integer;

begin
   WindowW   := lbChat.Width - btnSend.Glyph.Width;
   TextW     := lbChat.Canvas.TextWidth(lbChat.Items.Strings[Index]);
   //  
   LineCount := Trunc(TextW / WindowW) + 1;
   Height    := LineCount*lbChat.ItemHeight + 2;
   //  .  +   
   if (LineCount > 1) Then
      Begin
        Height := Height*lbChat.ItemHeight + LineCount*2 + 2;
      End;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.lbUserListMeasureItem(Control: TWinControl;
  Index: Integer; var Height: Integer);
begin
//   Height := 17;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.cbPrivateClick(Sender: TObject);
begin
   if (PrivEnabled) Then
   //    
      Begin
         ClnSock.Socket.SendText(ctrlSym + 'PUBLIC');
         lbUserList.Enabled := true;
         PrivEnabled        := false;
         cbPrivate.Checked  := PrivEnabled;
         if (lbUserList.ItemIndex < 0) Then cbPrivate.Enabled := false;
         exit;
      End
   else
   //   
      Begin
         if (lbUserList.ItemIndex > -1) Then
            Begin
               ClnSock.Socket.SendText(ctrlSym + 'PRIVATE' + delimSym +
                  lbUserList.Items[lbUserList.ItemIndex]);
               PrivEnabled        := true;
               lbUserList.Enabled := false;
            End;
         cbPrivate.Checked  := PrivEnabled;
      End;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.lbUserListDblClick(Sender: TObject);
begin
   edChat.Text := edChat.Text + lbUserList.Items.Strings[lbUserList.ItemIndex]
      + ', ';
   edChat.SelStart := Length(edChat.Text);    
   edChat.SetFocus;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.lbUserListClick(Sender: TObject);
begin
   if ((not cbPrivate.Enabled) and (lbUserList.ItemIndex > -1)) Then
      cbPrivate.Enabled := true;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.FormKeyPress(Sender: TObject; var Key: Char);
begin
   if (Key = #27) Then Close();
end;
//---------------------------------------------------------------------------
procedure TfrmMain.LoadSettings();
//  
Var StIniFile : TIniFile;
    ChatConfigDir: String;
    SkinIndex: Integer;
Begin
  ChatConfigDir := GetEnvironmentVariable('USERPROFILE') + PathDelim +
  'Application Data' + PathDelim + 'CrazyChat' + PathDelim;
  try
    StIniFile := TIniFile.Create(ChatConfigDir + 'chat.ini');
    try
      edPort.Text     := StIniFile.ReadString('Global', 'Port', IntToStr(DefPort));
      edAddress.Text  := StIniFile.ReadString('Global', 'IP', '192.168.');
      SkinIndex       := cbSkinSelect.Items.IndexOf(StIniFile.ReadString(
                         'Global', 'Skin', ''));
      //      ,      n.0
      if (SkinIndex < 0) Then SkinIndex := 0;
      cbSkinSelect.ItemIndex            := SkinIndex;
      cbSkinSelectSelect(cbSkinSelect);
      edNick.Text       := StIniFile.ReadString('NickSettings', 'NickName', '');
      edNick.Font.Color := StIniFile.ReadInteger('NickSettings', 'NickColor',
                                                DefNickColor);
      dlgClNick.Color   := edNick.Font.Color;
    finally
      StIniFile.Free;
    end;
  //   
  except
    exit;
  end;

End;
//---------------------------------------------------------------------------
procedure TfrmMain.SaveSettings();
//  
Var StIniFile : TIniFile;
    ChatConfigDir: String;

Begin
  ChatConfigDir := GetEnvironmentVariable('USERPROFILE') + PathDelim +
  'Application Data' + PathDelim + 'CrazyChat' + PathDelim;
  try
    if (not DirectoryExists(ChatConfigDir)) Then MkDir(ChatConfigDir);
    StIniFile := TIniFile.Create(ChatConfigDir + 'chat.ini');
    try
      StIniFile.WriteString('Global', 'Port', edPort.Text);
      StIniFile.WriteString('Global', 'IP', edAddress.Text);
      StIniFile.WriteString('Global', 'Skin',
                cbSkinSelect.Items.Strings[cbSkinSelect.ItemIndex]);
      StIniFile.WriteString('NickSettings', 'NickName', edNick.Text);
      StIniFile.WriteInteger('NickSettings', 'NickColor', edNick.Font.Color);
    finally
      StIniFile.Free;
    end;
  except
    exit;
  end;
End;
//---------------------------------------------------------------------------
function TfrmMain.LoadSkin(Skin: PSkinParam) : Boolean;
//   
Var FullSkinPath: String;
    SkinIniFile: TIniFile;
    ParamString: String;
    ParamInt: Integer;

  procedure FreeImgBgStatus();
  Begin
    imgBgStatus.Visible := false;
    imgBgStatus.Picture.Bitmap.FreeImage;
    imgBgStatus.Picture.Bitmap.Dormant;
    imgBgStatus.Picture.Bitmap.ReleaseHandle;
  End;

  procedure FreeImgBgType();
  Begin
    ImgBgType.Visible   := false;
    ImgBgType.Picture.Bitmap.FreeImage;
    ImgBgType.Picture.Bitmap.Dormant;
    imgBgType.Picture.Bitmap.ReleaseHandle;
  End;

  procedure LoadDefaultSkin;
  //     
  Begin
    //  
    FreeImgBgStatus();
    FreeImgBgType();
    lbChat.Color            := DefWndChatColor;
    lbChat.Font.Color       := DefWndChatTextColor;
    lbUserList.Color        := DefWndUsersColor;
    lbUserList.Font.Color   := DefWndUsersTextColor;
    edChat.Color            := DefWndTypeColor;
    edChat.Font.Color       := DefWndTypeTextColor;
    frmMain.Font.Color      := DefWndMainTextColor;
    Label1.Font.Color       := DefWndMainTextColor;
    Label2.Font.Color       := DefWndMainTextColor;
    Label3.Font.Color       := DefWndMainTextColor;
    Label4.Font.Color       := DefWndMainTextColor;
    Label5.Font.Color       := DefWndMainTextColor;
    cbPrivate.Font.Color    := DefWndMainTextColor;
    pnStatus.Color          := DefWndStatusBgColor;
    pnType.Color            := DefWndTypeBgColor;
    Lambda.NickColor           := DefLambdaColor;
    PrivRecvHL              := DefPrivRecvHL;
    PrivSendHL              := DefPrivSendHL;
    stAbout.Caption         := '';
    InvalidateRect(pnStatus.Handle, nil, true);
    InvalidateRect(pnChat.Handle, nil, true);
    InvalidateRect(pnType.Handle, nil, true);
    InvalidateRect(lbChat.Handle, nil, true);
    InvalidateRect(lbUserList.Handle, nil, true);
    stAbout.Caption         := '  ';
  End;

Begin
  if (Skin = nil) Then
  //    
    Begin
      LoadDefaultSkin();
      Result := true;
      exit;
    End;

  try
    FullSkinPath := IncludeTrailingPathDelimiter(
                    IncludeTrailingPathDelimiter(ExtractFileDir(ParamStr(0))) +
                    IncludeTrailingPathDelimiter(SkinPath) + Skin^.SkinDir);
    if (DirectoryExists(FullSkinPath)) Then
      Begin
        if (not FileExists(FullSkinPath + SkinMainFile)) Then raise
              Exception.Create('Skin file not exists!');
        SkinIniFile := TIniFile.Create(FullSkinPath + SkinMainFile);
        try
          ParamString := SkinIniFile.ReadString('images', 'bgControl', '');
          ParamString := FullSkinPath + ParamString;
          if (FileExists(ParamString)) Then
            Begin
              try
                imgBgStatus.Picture.LoadFromFile(ParamString);
                //        
                // ,    "" 
                imgBgStatus.Visible := true;
              except
              end;
            End
          else FreeImgBgStatus();
          ParamString := SkinIniFile.ReadString('images', 'bgType', '');
          ParamString := FullSkinPath + ParamString;
          if (FileExists(ParamString)) Then
            Begin
              try
                imgBgType.Picture.LoadFromFile(ParamString);
                imgBgType.Visible := true;
              except
              end;
            End
          else FreeImgBgType();

          ParamInt      := SkinIniFile.ReadInteger('colors', 'wndChatColor',
                                                    DefWndChatColor);
          lbChat.Color  := ParamInt;
          ParamInt      := SkinIniFile.ReadInteger('colors', 'wndChatTextColor',
                                                    DefWndChatTextColor);
          lbChat.Font.Color := ParamInt;
          ParamInt    := SkinIniFile.ReadInteger('colors', 'wndUsersColor',
                                                  DefWndUsersColor);
          lbUserList.Color := ParamInt;
          ParamInt    := SkinIniFile.ReadInteger('colors', 'wndUsersTextColor',
                                                  DefWndUsersTextColor);
          lbUserList.Font.Color := ParamInt;
          ParamInt    := SkinIniFile.ReadInteger('colors', 'wndTypeColor',
                                                  DefWndTypeColor);
          edChat.Color  := ParamInt;
          ParamInt      := SkinIniFile.ReadInteger('colors', 'wndTypeTextColor',
                                                    DefWndTypeTextColor);
          edChat.Font.Color := ParamInt;
          ParamInt      := SkinIniFile.ReadInteger('colors', 'wndMainTextColor',
                                                    DefWndMainTextColor);
          frmMain.Font.Color    := ParamInt;
          Label1.Font.Color     := ParamInt;
          Label2.Font.Color     := ParamInt;
          Label3.Font.Color     := ParamInt;
          Label4.Font.Color     := ParamInt;
          Label5.Font.Color     := ParamInt;
          cbPrivate.Font.Color  := ParamInt;
          stAbout.Font.Color    := ParamInt;

          ParamInt := SkinIniFile.ReadInteger('colors', 'wndStatusBgColor',
                                               DefWndStatusBgColor);
          pnStatus.Color  := ParamInt;
          ParamInt        := SkinIniFile.ReadInteger('colors', 'wndTypeBgColor',
                                                       DefWndTypeBgColor);
          pnType.Color      := ParamInt;
          ParamInt          := SkinIniFile.ReadInteger('colors', 'LambdaColor',
                                                       DefLambdaColor);
          Lambda.NickColor  := ParamInt;
          ParamInt          := SkinIniFile.ReadInteger('colors', 'PrivRecvHL',
                                                       DefPrivRecvHL);
          PrivRecvHL        := ParamInt;
          ParamInt          := SkinIniFile.ReadInteger('colors', 'PrivSendHL',
                                                       DefPrivSendHL);
          PrivSendHL        := ParamInt;
        finally
          stAbout.Caption := ' : '  + Skin^.SkinAuthor + #13 +
                             ' : ' + Skin^.SkinVersion;

          InvalidateRect(pnStatus.Handle, nil, true);
          InvalidateRect(pnChat.Handle, nil, true);
          InvalidateRect(pnType.Handle, nil, true);
          InvalidateRect(lbChat.Handle, nil, true);
          InvalidateRect(lbUserList.Handle, nil, true);
          SkinIniFile.Free;
        end;
      End
      else raise Exception.Create('');
  except
    Result := false;
    exit;
  end;
  Result := true;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.EnumSkins;
//   
Var FullSkinPath: String;
    SkinFile: String;
    SkinParams: PSkinParam;
    F: TSearchRec;
    SkinIniFile: TIniFile;

Begin
  FullSkinPath := IncludeTrailingPathDelimiter(
                  IncludeTrailingPathDelimiter(ExtractFileDir(ParamStr(0))) +
                  SkinPath
                  );
  if (FindFirst(FullSkinPath + '*.*', faDirectory, F) <> 0) Then exit;
  repeat
    if ((F.Name = '.') or (F.Name = '..')) Then continue;
    SkinFile := IncludeTrailingPathDelimiter(FullSkinPath + F.Name)
                                             + SkinMainFile;
    if (not FileExists(SkinFile)) Then continue;
    SkinIniFile := TIniFile.Create(SkinFile);    
    try
      New(SkinParams);
      with SkinParams^ do
      Begin
        SkinDir     := F.Name;
        SkinName    := SkinIniFile.ReadString('general', 'SkinName', F.Name);
        //        ( ),  
        if (Trim(SkinName) = '') Then SkinName := 'unknown';
        SkinAuthor  := SkinIniFile.ReadString('general', 'SkinAuthor', '');
        SkinVersion := SkinIniFile.ReadString('general', 'SkinVersion', '1');
        cbSkinSelect.Items.AddObject(SkinName, TObject(SkinParams));
      End;
    finally
      SkinIniFile.Free;
    end;
  until (FindNext(F) <> 0);
End;
//---------------------------------------------------------------------------
procedure TfrmMain.cbSkinSelectSelect(Sender: TObject);
begin
  with cbSkinSelect.Items do
    if (not LoadSkin(PSkinParam(Objects[cbSkinSelect.ItemIndex])))
      Then
        Begin
          cbSkinSelect.ItemIndex := 0;
        End;

end;
//---------------------------------------------------------------------------
procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
//       
begin
  if ((Action = caHide) or (Action = caFree)) Then
    Begin
      if (ClnSock.Active) Then ClnSock.Close;
      ClnSock.Free();
    End;
end;
end.

