unit SplashUnit;

interface

uses
  Windows, Classes, ExtCtrls, Forms, Messages, SysUtils, Graphics, JPEG, Controls,
  ComCtrls, XPMan, ActnMan, ActnColorMaps;
{, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;}
const PicNum   =  5; //  splash 
   {$I ../inc/consts.inc}
   Msg0 = 'Crazy Chat Client v.' + ChatVersion;
   Msg1 = 'Created by Artiom N.(cl)2006';

type
  TfrmSplash = class(TForm)
    tmSplash: TTimer;
    tmTransp: TTimer;
    pbStatus: TProgressBar;
    tmProgress: TTimer;
    procedure tmSplashTimer(Sender: TObject);
    procedure tmTranspTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure tmProgressTimer(Sender: TObject);
  private
    FCurAlpha: Integer;
    FBMP : TBitmap;
    { Private declarations }
  protected
    procedure WMEraseBkGnd(var Message: TWMEraseBkGnd); message WM_ERASEBKGND;
  public
    { Public declarations }
  end;

var
  frmSplash: TfrmSplash;

implementation

{$R *.dfm}

procedure TfrmSplash.tmSplashTimer(Sender: TObject);
begin
   tmSplash.Enabled := false;
   Close;
end;
//---------------------------------------------------------------------------
procedure TfrmSplash.tmTranspTimer(Sender: TObject);
begin
   FCurAlpha := AlphaBlendValue + 10;
   if (FCurAlpha >= 255) Then
      Begin
         AlphaBlend        := false;
         tmTransp.Enabled  := false;
      End
   else AlphaBlendValue    := FCurAlpha;
end;
//---------------------------------------------------------------------------
procedure TfrmSplash.FormCreate(Sender: TObject);
Var ResStream: TResourceStream;
    JPG : TJPEGImage;
begin
   ResStream   := TResourceStream.Create(hInstance, 'SPL_PIC' +
      IntToStr(Random(PicNum)), RT_RCDATA);
   JPG         := TJPEGImage.Create;
   FBMP        := TBitmap.Create;
   JPG.LoadFromStream(ResStream);
   FBMP.Assign(JPG);
   JPG.Free;
   ResStream.Free;
   Canvas.Font          := Font;
   Canvas.Brush.Style   := bsSolid;
   Canvas.Brush.Color   := clBlack;
   ControlStyle         := ControlStyle + [csOpaque];
   pbStatus.ControlStyle := pbStatus.ControlStyle + [csOpaque];
   PostMessage(pbStatus.Handle, $0409, 0, clGreen);
   tmProgress.Interval  := Trunc(tmSplash.Interval/pbStatus.Max);
   tmProgress.Enabled   := True;
   tmSplash.Enabled     := True;
end;
//---------------------------------------------------------------------------
procedure TfrmSplash.FormDestroy(Sender: TObject);
begin
   FBMP.Free;
end;
//---------------------------------------------------------------------------
procedure TfrmSplash.WMEraseBkGnd(var Message: TWMEraseBkGnd);
Var
   row, col, cx: Integer;

begin
    for Row := 0 to ClientHeight div FBMP.Height do
       for Col := 0 to ClientWidth div FBMP.Width do
         BitBlt(Message.Dc,
           Col * FBMP.Width,
           Row * FBMP.Height,
           FBMP.Width,
           FBMP.Height,
           FBMP.Canvas.Handle,
           0,
           0,
           SRCCOPY);
     Message.Result := 1;
     cx := Trunc((ClientWidth - Canvas.TextWidth(Msg0))/2);
     Canvas.TextOut(cx, 20, Msg0);
     cx := Trunc((ClientWidth - Canvas.TextWidth(Msg1))/2);
     Canvas.TextOut(cx, ClientHeight - Canvas.TextHeight(Msg1) -
      pbStatus.Height - 20, Msg1);
 end;
//---------------------------------------------------------------------------
procedure TfrmSplash.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   CanClose := false;
end;

procedure TfrmSplash.tmProgressTimer(Sender: TObject);
begin
   pbStatus.Position := pbStatus.Position + pbStatus.Step;
end;
//      ...
//     ,
//       ,
//    .
//
//       .
//      .
//  ,    .
//     .
//
//      .
//     "",
//     ,
//  ,    .
//
//      ,
//      ,
//   .
//   ,  ,    .
//
//     .
//   ,   ,
//   ,   .
//      ...
//
// . , 1939
end.
