; CrazyChat.nsi
;
; CrazyChat Installer
;--------------------------------
!include "MUI.nsh"
!define VERSION "v.0.3a"
!define NAME "CrazyChat ${VERSION}"
!define RegKey "Software\Microsoft\Windows\CurrentVersion\Uninstall\${NAME}"

!define USERINCLUDE "..\Installer"
!addincludedir ${USERINCLUDE}
!packhdr temp.dat "upx --best temp.dat"
SetCompressor lzma

XPStyle on
OutFile Setup.exe
Name "${NAME}"
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "CrazyChat"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT HKLM
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${RegKey}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "StartMenu"

!define MUI_FINISHPAGE_RUN "$INSTDIR\chat_Server.exe"
!define MUI_FINISHPAGE_RUN_TEXT "$(msgRunServer)"
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\chat_Client.exe"
!define MUI_FINISHPAGE_SHOWREADME_TEXT "$(msgRunClient)"
; READ_ME
!define MUI_FINISHPAGE_LINK "$(msgShowReadMe)"
!define MUI_FINISHPAGE_LINK_LOCATION "$INSTDIR\READ_ME.txt"

!define MUI_LANGDLL_REGISTRY_ROOT HKLM
!define MUI_LANGDLL_REGISTRY_KEY "${RegKey}"
!define MUI_LANGDLL_REGISTRY_VALUENAME "LangDLL"
!define MUI_COMPONENTSPAGE_SMALLDESC
!define MUI_ICON "modern-install-blue-full.ico"
!define MUI_UNICON "modern-uninstall-blue-full.ico"
!define MUI_BGCOLOR "FFFFFF"
!define MUI_LICENSEPAGE_BGCOLOR /gray
!define MUI_INSTFILESPAGE_COLORS "00ff00 000000"
!define MUI_INSTFILESPAGE_PROGRESSBAR ""
!define MUI_WELCOMEFINISHPAGE_BITMAP "llama.bmp"
!define MUI_UNWELCOMEFINISHPAGE_BITMAP "llama.bmp"
!define MUI_FINISHPAGE_NOAUTOCLOSE
!define MUI_UNFINISHPAGE_NOAUTOCLOSE
!define MUI_COMPONENTSPAGE_CHECKBITMAP "${NSISDIR}\Contrib\Graphics\Checks\colorful.bmp"

;!define MUI_UI "modern.exe"

;-------------------------------

ShowUninstDetails show
ShowInstDetails show

;-------------------------------

Var MenuFolder
Var RK

!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_LICENSE $(myLicenseData)

!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_STARTMENU Application $MenuFolder
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH

!insertmacro MUI_UNPAGE_WELCOME
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

;--------------------------------

!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "Russian"

;--------------------------------
LicenseLangString myLicenseData ${LANG_ENGLISH} "eng_lic.txt"
LicenseLangString myLicenseData ${LANG_RUSSIAN} "rus_lic.txt"
LicenseData $(myLicenseData)
;--------------------------------

InstallDir "$PROGRAMFILES\CrazyChat"
InstallDirRegKey HKLM "${RegKey}" "Instdir"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT HKLM
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${RegKey}\StartMenu" 
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "StartMenuFolder"
  
;-------------------------------

!macro SetLangString StrName  EText RText
	LangString ${StrName} ${LANG_ENGLISH} "${EText}"
	LangString ${StrName} ${LANG_RUSSIAN} "${RText}"
!macroend

;-------------------------------

!insertmacro SetLangString msgRunServer "Run server" " "
!insertmacro SetLangString msgRunClient "Run client" " "
!insertmacro SetLangString msgShowReadMe "Show Readme" " Readme"
!insertmacro SetLangString msgReinstallText \
	"Previous installation was found.$\nWould you like to uninstall it?" \
	"Previous installation was found.$\nWould you like to uninstall it?"
;	"   .$\n ?"
!insertmacro SetLangString sectionMainName "CrazyChat executables" " "
!insertmacro SetLangString sectionDocsName "CrazyChat manuals" ""
!insertmacro SetLangString sectionSkinsName "CrazyChat skins" ""
!insertmacro SetLangString subsDocsDescrName "Techical notes" " "
!insertmacro SetLangString subsDocsSkinkitName "Skin kit" "   "
!insertmacro SetLangString shortcutDescr "Description.lnk" ".lnk"
!insertmacro SetLangString shortcutClient "Client.lnk" ".lnk"
!insertmacro SetLangString shortcutServer "Server.lnk" ".lnk"
!insertmacro SetLangString shortcutSSkin "Sample skin.lnk" "-.lnk"
!insertmacro SetLangString shortcutSMan "Skin creators manual.lnk" "  .lnk"
!insertmacro SetLangString shortcutUninstall "Uninstall.lnk" ".lnk"
!insertmacro SetLangString tinstFull "Full" " "
!insertmacro SetLangString tinstMinimal "Minimal" ""

;--------------------------------
InstType $(tinstFull)
InstType $(tinstMinimal)
;-------------------------------

!cd "..\ChatDistr"
Section "-Install"
	SetOutPath $INSTDIR
SectionEnd
;++++++++++++++++++++++++++++++++
Section $(sectionMainName) sectionMain
	SectionIn 1 2 RO
	File "*.exe"
	File "*.txt"
	WriteUninstaller "uninstall.exe"
	; write uninstall strings
	WriteRegStr HKLM "${RegKey}" "DisplayName" "${NAME}"
	WriteRegStr HKLM "${RegKey}" "DisplayIcon" "$INSTDIR\chat_Client.exe"
	WriteRegStr HKLM "${RegKey}" "UninstallString" '"$INSTDIR\uninstall.exe"'
	WriteRegStr HKLM "${RegKey}" "Publisher" "Artiom N."
	WriteRegStr HKLM "${RegKey}" "Readme" "$INSTDIR\READ_ME.txt"
	WriteRegDWORD HKLM "${RegKey}" "NoModify" 1
	WriteRegDWORD HKLM "${RegKey}" "NoRepair" 1
	!insertmacro MUI_STARTMENU_WRITE_BEGIN Application
		CreateDirectory "$SMPROGRAMS\$MenuFolder"
		CreateShortCut "$SMPROGRAMS\$MenuFolder\$(shortcutClient)" \
						"$INSTDIR\chat_Client.exe"
		CreateShortCut "$SMPROGRAMS\$MenuFolder\$(shortcutServer)" \
						"$INSTDIR\chat_Server.exe"
		CreateShortCut "$SMPROGRAMS\$MenuFolder\ReadMe.lnk" \
						"$INSTDIR\READ_ME.txt"
		CreateShortCut "$SMPROGRAMS\$MenuFolder\$(shortcutUninstall)"\
						"$INSTDIR\uninstall.exe"
	!insertmacro MUI_STARTMENU_WRITE_END
SectionEnd
;++++++++++++++++++++++++++++++++
SubSection $(sectionDocsName) sectionDocs
	Section $(subsDocsDescrName) subsDocsDescr
		SectionIn 1
		Call CreateDocFolders
		File "docs\_descr.txt"
		CreateShortCut "$SMPROGRAMS\$MenuFolder\$(sectionDocsName)\$(shortcutDescr)" \
						"$INSTDIR\docs\_descr.txt"
	SectionEnd
	
	Section $(subsDocsSkinkitName) subsDocsSkinkit
		SectionIn 1
		Call CreateDocFolders
		File /r "docs\skinkit"
		CreateShortCut "$SMPROGRAMS\$MenuFolder\$(sectionDocsName)\$(shortcutSMan)" \
						"$INSTDIR\docs\skinkit\CreatingSkin.htm"
		CreateShortCut "$SMPROGRAMS\$MenuFolder\$(sectionDocsName)\$(shortcutSSkin)" \
						"$INSTDIR\docs\skinkit\sampleskin"
	SectionEnd
SubSectionEnd
;++++++++++++++++++++++++++++++++
SubSection $(sectionSkinsName) sectionSkins
	!include "${USERINCLUDE}\SkinSections.nsi"
SubSectionEnd
;++++++++++++++++++++++++++++++++
Section "Uninstall"
	Delete "$SMPROGRAMS\$MenuFolder\*.*"
	Delete "$SMPROGRAMS\$MenuFolder\$(sectionDocsName)\*.*"
	RMDir "$SMPROGRAMS\$MenuFolder\$(sectionDocsName)"
	RMDir "$SMPROGRAMS\$MenuFolder"

	!include "${USERINCLUDE}\SkinUnInst.nsi"
	Delete "$INSTDIR\docs\skinkit\sampleskin\*.*"
	Delete "$INSTDIR\docs\skinkit\*.*"
	RMDir "$INSTDIR\docs\skinkit\sampleskin"
	RMDir "$INSTDIR\docs\skinkit"
	Delete "$INSTDIR\docs\*.*"
	RMDir "$INSTDIR\docs"
	Delete "$INSTDIR\*.*"
	RMDir "$INSTDIR"
	DeleteRegKey HKLM "${RegKey}"
SectionEnd

;--------------------------------

!cd "..\Installer"

!insertmacro SetLangString DESCR_SecMain "CrazyChat executables and some docs" \
			",  ,    "
!insertmacro SetLangString DESCR_SecDocs "Manuals" ""
!insertmacro SetLangString DESCR_SecSkins "Skins" ""
!insertmacro SetLangString DESCR_SubSecDocsSkinkit "Skin-creators manual with \
skin settings sample file and template pictures" \
	"   ,       -"

!insertmacro SetLangString DESCR_SubSecDocsDescr "Technical description of the \
program and chat protocol" \
	"    "

!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
	!insertmacro MUI_DESCRIPTION_TEXT ${sectionMain} $(DESCR_SecMain)
	!insertmacro MUI_DESCRIPTION_TEXT ${sectionDocs} $(DESCR_SecDocs)
	!insertmacro MUI_DESCRIPTION_TEXT ${sectionSkins} $(DESCR_SecSkins)
	!insertmacro MUI_DESCRIPTION_TEXT ${subsDocsSkinkit} $(DESCR_SubSecDocsSkinkit)
	!insertmacro MUI_DESCRIPTION_TEXT ${subsDocsDescr} $(DESCR_SubSecDocsDescr)
	!include "${USERINCLUDE}\SkinDescrs.nsi"
!insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
Function .onInit
	SetShellVarContext all
	!define MUI_LANGDLL_ALWAYSSHOW
	;   . 
	ReadRegStr $RK HKLM "${RegKey}" "UninstallString"
	IfErrors no_prev_insts
		MessageBox MB_YESNO|MB_ICONQUESTION "$(msgReinstallText)" IDNO no_prev_insts
		;  
		ExecWait "$RK /S"
	no_prev_insts:
	!insertmacro MUI_LANGDLL_DISPLAY
FunctionEnd
;--------------------------------
Function un.onInit
	SetShellVarContext all
	!insertmacro MUI_UNGETLANGUAGE
	!insertmacro MUI_STARTMENU_GETFOLDER Application $MenuFolder
FunctionEnd
;--------------------------------
Function CreateDocFolders
	!insertmacro MUI_STARTMENU_WRITE_BEGIN Application
		CreateDirectory "$SMPROGRAMS\$MenuFolder\$(sectionDocsName)"
	!insertmacro MUI_STARTMENU_WRITE_END
	CreateDirectory "$INSTDIR\docs"
	SetOutPath "$INSTDIR\docs"
FunctionEnd
;--------------------------------
Function SetSkinsParams
	CreateDirectory "$INSTDIR\Skins"
	SetOutPath "$INSTDIR\Skins"
FunctionEnd